# This module is part of the Pyndex project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

from pyndex.indexer import Index
import os, string

    
filedir = './aesop/'
indexName = 'aesopind.mk'

if os.path.exists(indexName):
    # Remove results of previous runs
    os.remove(indexName)

import time
tt = time.time()

# Create a new Index
index = Index(indexName, readOnly=False)

# Get the files
files = os.listdir(filedir)
for f in files:
    text = open(filedir + f).read()

    print 'indexing:', f
    id = f.split('.')[0]
    n = int(id)
    # use the file name as the file's unique id string in Pyndex
    row, exists = index.index(n, text)
    # if the row is new, we will set its name
    if not exists:
        row.docname = f

index.commit()
# get rid of index
del(index)

# re-open it for search
index = Index(indexName, readOnly=True)

print 'fox:', index.find('fox')
print 'python:', index.find('python')
print 'fox stork', index.find('fox stork')
print 'fox python', index.find('fox python')
print '"the fox and the":', index.find('"the fox and the"')
print '"the fox and python":', index.find('"the fox and python"')

print time.time() - tt


