# This module is part of the Pyndex project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

import os, sys
import email, email.Iterators, email.Errors
import time

from pyndex.indexer import Index


filedir = sys.argv[1]
indexName = 'emailindex.mk'

tt = time.time()

# Create a new Index
index = Index('emailindex.mk', create=True)

# Get the files
files = os.listdir(filedir)

for f in files:
    print 'Indexing', f
    fp = open(os.path.join(filedir, f))
    try:
        msg = email.message_from_file(fp)
    except email.Errors.MessageParseError:
        print 'Bad msg:', f
        continue

    subj = msg.get('subject', '<No Subject>')

    body = None
    for part in msg.walk():
        typ = part.get_type()
        if typ and typ.lower() == "text/plain":
            # Found the first text/plain part
            body = part.get_payload(decode=True)
            break
    
    if body is None:
        body = ''
    
    index.index(f, subj + ' ' +  body)

index.commit()

# pretend it never happened
del(index)

# re-open it for search
index = Index(metakit.storage(indexName,0))

print 'today', index.find('today')

print time.time() - tt


