# This module is part of the Pyndex project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

"""
Test cases for Pyndex.
"""

#from pyunit import unittest
import unittest
from pyndex.indexer import Index

class IndexerTestCase(unittest.TestCase):
    
    text1 = """The quick brown fox wasn't quick enough and got eaten by the hounds."""
    text2 = """The hounds of doom are quick and prowl the nine circles of hell."""

    def testIndexing(self):
        index = Index()
        index.index(1, self.text1)
        
        res = index.find('quick')
        self.failUnlessEqual(res, {'quick': [(1, 2, 13)]})
        
        res = index.find('quick egg')
        self.failUnlessEqual(res, {'quick': [(1, 2, 13)]})
        
        res = index.find('quick fox')
        self.failUnlessEqual(res, {'quick': [(1, 2, 13)],
                                   'fox': [(1, 1, 13)]})
        
        res = index.find('fast')
        self.failUnlessEqual(res, {})

        index.index(2, self.text2)
        
        res = index.find('doom')
        self.failUnlessEqual(res, {'doom': [(2, 1, 13)]})
                
        res = index.find('quick')
        self.failUnlessEqual(res, {'quick': [(1, 2, 13), (2, 1, 13)]})

        index.write('testindex.mk')

        
testCases = [IndexerTestCase]

if __name__ == "__main__":
    unittest.main()
